/*
 * Word counter, generation 3
 * Jari Komppa 1999
 *
 * - checksum ("hash") values put into static array
 */

#include "wc.cpp"

typedef struct itemstruct {
  itemstruct * next;
  char * data;
  int hits;
  int hash;
} ITEM;

typedef struct hashlist {
  int hash;
  struct itemstruct * item;
} HASHLIST;

HASHLIST hlist[300000];
int hlist_top=0;

int hash(char * str) {
  char * p;
  int h,t;
  h=0;
  p=str;
  while (*p) {
    t=h>>(32-5);
    h<<=5;
    h+=t; // rol 5
    h+=*p;
    p++;
  }
  return h;
}

ITEM * root;

void init_gen(void)
{
  root=NULL;
}

void traverse(ITEM * i) {	
	insert_sort(i);
	if (i->next!=NULL) traverse(i->next);
}

void report(void)
{
	printf("Generating report..\n");
	traverse(root);
	SORTITEM *i=sroot;
	FILE * f;
	f=fopen("output.txt","wb");
	while (i!=NULL) {
		fprintf(f,"%8i %s\r\n",i->hits,i->data);
		i=i->next;
	}
	fclose(f);
}

int insert_word(char * new_word)
{
  if (new_word==NULL) return 0;
  int newhash=hash(new_word);
  ITEM * item;
  item=root;
  for (int i=0;i<hlist_top;i++)
    if (hlist[i].hash==newhash)
      if (strcmp(hlist[i].item->data,new_word)==0) {
        hlist[i].item->hits++;
        return 1;
      }
  item=(ITEM*)malloc(sizeof(ITEM));
  item->next=root;
  item->data=strdup(new_word);
  item->hits=1;
  item->hash=newhash;
  root=item;

  hlist[hlist_top].hash=newhash;
  hlist[hlist_top].item=item;
  hlist_top++;

  return 1;
}
