/*
 * Word counter, generation 4
 * Jari Komppa 1999
 *
 * - radix (8bit) based tree implementation
 */

#include "wc.cpp"

typedef struct itemstruct {
  itemstruct * child;
  itemstruct * sibling;
  char * data;
  int hits;
  int hash;
} ITEM;

int hash(char * str) {
  char * p;
  int h,t;
  h=0;
  p=str;
  while (*p) {
    t=h>>(32-5);
    h<<=5;
    h+=t; // rol 5
    h+=*p;
    p++;
  }
  return h;
}

ITEM * root;

void init_gen(void)
{
  root=NULL;
}

void traverse(ITEM * i) {
	insert_sort(i);
	if (i->sibling!=NULL) traverse(i->sibling);
	if (i->child!=NULL) traverse(i->child);
}

void report(void)
{
	printf("Generating report..\n");
	traverse(root);
	SORTITEM *i=sroot;
	FILE * f;
	f=fopen("output.txt","wb");
	while (i!=NULL) {
		fprintf(f,"%8i %s\r\n",i->hits,i->data);
		i=i->next;
	}
	fclose(f);
}

int insert_word(char * new_word)
{
  if (new_word==NULL) return 0;
  int newhash=hash(new_word);
  int radix;
  ITEM * item, * last;
  last=item=root;
  if (root==NULL) {
    item=(ITEM*)malloc(sizeof(ITEM));
    item->child=item->sibling=NULL;
    item->data=strdup(new_word);
    item->hits=1;
    item->hash=newhash;
    root=item;
    return 1;
  }
  radix=0;
  while (1) {
    if (item->hash==newhash)
      if (strcmp(item->data,new_word)==0) {
        item->hits++;
        return 1;
      }
    if (item->data[radix]==new_word[radix]) {
      last=item;
      item=item->child;
      radix++;
      if (item!=NULL) continue;
      item=(ITEM*)malloc(sizeof(ITEM));
      item->child=item->sibling=NULL;
      item->data=strdup(new_word);
      item->hits=1;
      item->hash=newhash;
      last->child=item;
      return 1;
    }
    last=item;
    item=item->sibling;
    if (item!=NULL) continue;
    item=(ITEM*)malloc(sizeof(ITEM));
    item->child=item->sibling=NULL;
    item->data=strdup(new_word);
    item->hits=1;
    item->hash=newhash;
    last->sibling=item;
    return 1;
  }
}
